// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from radar_msgs:msg/RadarTrack.idl
// generated code does not contain a copyright notice
#include "radar_msgs/msg/detail/radar_track__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `uuid`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `position`
#include "geometry_msgs/msg/detail/point__functions.h"
// Member `velocity`
// Member `acceleration`
// Member `size`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
radar_msgs__msg__RadarTrack__init(radar_msgs__msg__RadarTrack * msg)
{
  if (!msg) {
    return false;
  }
  // uuid
  if (!unique_identifier_msgs__msg__UUID__init(&msg->uuid)) {
    radar_msgs__msg__RadarTrack__fini(msg);
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__init(&msg->position)) {
    radar_msgs__msg__RadarTrack__fini(msg);
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__Vector3__init(&msg->velocity)) {
    radar_msgs__msg__RadarTrack__fini(msg);
    return false;
  }
  // acceleration
  if (!geometry_msgs__msg__Vector3__init(&msg->acceleration)) {
    radar_msgs__msg__RadarTrack__fini(msg);
    return false;
  }
  // size
  if (!geometry_msgs__msg__Vector3__init(&msg->size)) {
    radar_msgs__msg__RadarTrack__fini(msg);
    return false;
  }
  // classification
  // position_covariance
  // velocity_covariance
  // acceleration_covariance
  // size_covariance
  return true;
}

void
radar_msgs__msg__RadarTrack__fini(radar_msgs__msg__RadarTrack * msg)
{
  if (!msg) {
    return;
  }
  // uuid
  unique_identifier_msgs__msg__UUID__fini(&msg->uuid);
  // position
  geometry_msgs__msg__Point__fini(&msg->position);
  // velocity
  geometry_msgs__msg__Vector3__fini(&msg->velocity);
  // acceleration
  geometry_msgs__msg__Vector3__fini(&msg->acceleration);
  // size
  geometry_msgs__msg__Vector3__fini(&msg->size);
  // classification
  // position_covariance
  // velocity_covariance
  // acceleration_covariance
  // size_covariance
}

radar_msgs__msg__RadarTrack *
radar_msgs__msg__RadarTrack__create()
{
  radar_msgs__msg__RadarTrack * msg = (radar_msgs__msg__RadarTrack *)malloc(sizeof(radar_msgs__msg__RadarTrack));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(radar_msgs__msg__RadarTrack));
  bool success = radar_msgs__msg__RadarTrack__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
radar_msgs__msg__RadarTrack__destroy(radar_msgs__msg__RadarTrack * msg)
{
  if (msg) {
    radar_msgs__msg__RadarTrack__fini(msg);
  }
  free(msg);
}


bool
radar_msgs__msg__RadarTrack__Sequence__init(radar_msgs__msg__RadarTrack__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  radar_msgs__msg__RadarTrack * data = NULL;
  if (size) {
    data = (radar_msgs__msg__RadarTrack *)calloc(size, sizeof(radar_msgs__msg__RadarTrack));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = radar_msgs__msg__RadarTrack__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        radar_msgs__msg__RadarTrack__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
radar_msgs__msg__RadarTrack__Sequence__fini(radar_msgs__msg__RadarTrack__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      radar_msgs__msg__RadarTrack__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

radar_msgs__msg__RadarTrack__Sequence *
radar_msgs__msg__RadarTrack__Sequence__create(size_t size)
{
  radar_msgs__msg__RadarTrack__Sequence * array = (radar_msgs__msg__RadarTrack__Sequence *)malloc(sizeof(radar_msgs__msg__RadarTrack__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = radar_msgs__msg__RadarTrack__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
radar_msgs__msg__RadarTrack__Sequence__destroy(radar_msgs__msg__RadarTrack__Sequence * array)
{
  if (array) {
    radar_msgs__msg__RadarTrack__Sequence__fini(array);
  }
  free(array);
}
